import db from '../db.js';
import { ProxyAgent } from 'undici';

class ProxyService {
    async add(proto, host, port, username, password) {
        await db.query("INSERT INTO proxies (proto, host, port, username, password) VALUES ($1, $2, $3, $4, $5)", [proto, host, port, username, password]);
    }

    async take() {
        // while (true) {
            let proxy = (await db.query("UPDATE proxies SET claimed = TRUE WHERE id = ( SELECT id FROM proxies WHERE claimed = FALSE ORDER BY id LIMIT 1 ) RETURNING id, proto, host, port, username, password")).rows[0]
            return proxy == undefined? undefined : proxy;
            
            // console.log("testing proxy")
            // if (await this.check_connection(proxy)) return proxy;
            // else await this.delete(proxy.id)
            // console.log("Proxy failed and deleted")
        // }
    }

    // async check_connection(proxy) {
    //     const dispatcher = new ProxyAgent(`${proxy.proto}://${proxy.username? proxy.username + "@" + proxy.password + ":" : ""}${proxy.host}:${proxy.port}`);
    //     let response;
    //     try {
    //         response = await fetch("https://google.com", {dispatcher})
    //     } catch (e) {
    //         console.log(`Error on testing the proxy`)
    //         return false
    //     }
    //     return response.status == 200;
    // }

    async give_back(id) {
        await db.query("UPDATE proxies SET claimed = false WHERE id = $1", [id]);
    }

    async delete(id) {
        await db.query("DELETE FROM proxies WHERE id = $1", [id]);
    }
}

export default new ProxyService();